local Boid = class:extend("Boid")

function Boid:__init__(kwargs)

	self.x,self.y,self.angle = kwargs.x or 0
	self.y = kwargs.y or 0
	self.angle = kwargs.angle or 1
	self.crowded = 0
	self.vx, self.vy = kwargs.vx or 30, kwargs.vy or 30
	self.de = 1
	self.sight = 10
	self.dd=1
	self.maxForce = 1
	self.w, self.h = size/2, size/2
	self.isBoid = 1
	world:add(self, self.x, self.y, self.w, self.h)
	self.bx, self.by =0,0

	return t
end

function Boid:update(i,dt,field)
 
	local dx,dy = math.cos(self.angle),math.sin(self.angle)
	
    dx, dy = dx, dy
    
	if self then assert(self.dd==self.de)
	    local nx, ny = self.x+self.bx+dx*self.de*self.vx*dt,
	    self.y+self.by+dy*self.de*self.vy*dt
	    self.de=1
	    self.dd=1
	    self.x, self.y = self:move(nx,ny,dt)
	end
	
	local neighbors = {}
	for j,boid in ipairs(field) do
		if dist(boid.x,boid.y,self.x,self.y) <= self.w*2 and j~= i then table.insert(neighbors,boid) end
	end
	
	local num = #neighbors
	self.crowded = math.min(num,20)
	if num >= 0 then
		local totalx,totaly = 0,0
		local totalangle = 0
		local closest = {x=math.huge,y=math.huge}
		for _,boid in ipairs(neighbors) do
			totalx,totaly = boid.x+totalx,boid.y+totaly
			totalangle = boid.angle + totalangle
			if dist(closest.x,closest.y,self.x,self.y) > dist(boid.x,boid.y,self.x,self.y) then
				closest = {x=boid.x,y=boid.y}
			end
		end
		local avg_pos = {x=totalx/num,y=totaly/num}
		local avg_pos_angle = math.atan2(avg_pos.y-self.y,avg_pos.x-self.x)
		local avg_angle = totalangle/num
		local counter_angle = math.atan2(self.y-closest.y,self.x-closest.x)
            local i = closest
            local dis = dist( i.x,i.y, self.x,self.y,true)
            local sdis = math.sqrt(dis)
            local dista = 1/sdis
            --if math.floor(dista)<1
            --then dista =1 end
           if 1 then--intersects(ahead1,ahead2,i) then
        
                i.collided = 1
             -- if intersects(ahead1,ahead2,i) then 
                --self.de = self.de *dista*20
		end
		--self:adjustAngle(avg_pos_angle,dt,2)
		--self:adjustAngle(avg_angle,dt,2)
		self:adjustAngle(counter_angle,dt,1)--num/5)
	end
	if cursor.press then
	    if not self.path then
		
		   self:findPathTo(cursor)
		   self.currentPosInPath = 1
		end
		local cursor = cursor
		if self.path then
		    cursor = self.path[self.currentPosInPath]
		    local f = getTileP(self.x,self.y) --assert(not f)
		    if cursor then
		        self.currentPosInPath = self.currentPosInPath+1
		    end
		    if not cursor then
		        self.path = nil
		        cursor = _G.cursor
		    else
		        cursor.x=cursor.x*size+size/2
		        cursor.y =cursor.y*size+size/2
		        end
		       
		end
		local cursor_angle = math.atan2(cursor.y-self.y,cursor.x-self.x)
		if self.doneP~=self.currentPosInPath then 
		    self:adjustAngle(cursor_angle,dt,2)
		    --self.doneP=self.currentPosInPath
		end

	end
	--self.de = 1
	local dx, dy = math.cos(self.angle), math.sin(self.angle)
	local nx, ny = vector.normalize(dx,dy)
	local ahead1, ahead2 = {},{}
	ahead1.x = self.x+nx+self.sight
	ahead1.y = self.y+ny+self.sight
	ahead2.x = self.x+nx+self.sight*.5
	ahead2.y = self.y+ny+self.sight*.5
	
    for x, i in ipairs({}) do
        local dis = dist(i.x,i.y, self.x,self.y,true)
        local sdis = math.sqrt(dis)
        local dista = 1/sdis
        if math.floor(dista)<1
        then dista =1 end
        if sdis<50 then--intersects(ahead1,ahead2,i) then
        --[[self.cx = ahead1.x-getCenter(i).x
        self.cy = ahead1.y-getCenter(i).y
        self.cx, self.cy = vector.normalize(self.cx, self.cy)
        self.cx, self.cy = self.cx*self.maxForce, self.cy*self.maxForce]]
        i.collided = 1
	    	local counter_angle = math.atan2((self.y-i.y)*1000,(self.x-i.x)*1000)
		    self:adjustAngle(counter_angle,dt,1)--num/5)
       -- if intersects(ahead1,ahead2,i) then 
     --  self.de = self.de *dista 
       end
    end
        
end

function warn()
    _warn = 2
end

function getCenter(obj)
    local x = obj.x+obj.w/2
    local y = obj.y+(obj.h or obj.w)/2
    return {x=x,y=y}
end

function intersects(ahead, ahead2, obj)
    return-- dist(getCenter(obj),ahead)<=obj.w/2 or
    dist(getCenter(obj),ahead2)<=obj.w/2
end

function Boid:checkCollision(other)
    if other.isObstacle then
        return "slide"
    else return "bounce" end
end

function Boid:move(x,y,dt)
    self.de = 1
	local dx, dy = math.cos(self.angle), math.sin(self.angle)
	local nx, ny = vector.normalize(dx,dy)
	local ahead1, ahead2 = {},{}
	ahead1.x = self.x+nx+self.sight
	ahead1.y = self.y+ny+self.sight
	ahead2.x = self.x+nx+self.sight*.5
	ahead2.y = self.y+ny+self.sight*.5
--	self.bx, self.by = 0,0
    local actualX, actualY, collisions, len = world:move(self,x,y,
    self.checkCollision)
    local cc
    self.oldc = self.oldc and self.col
    for u = 1,len do
        local cc = collisions[u]
        local i = cc.other
        self.col = collisions[1].other
        if self.col then
            
            local dis = dist(i.x,i.y, self.x,self.y,true)
            local sdis = math.sqrt(dis)
            local dista = 1/sdis
            --if math.floor(dista)<1
            --then dista =1 end
	    	local counter_angle = math.atan2((self.y-i.y),(self.x-i.x))
	    	local x, y = math.cos(counter_angle), math.sin(counter_angle)
	    	self.bx = self.bx+x*dt*self.vx*1
	    	self.by = self.by+y*self.vy*dt*1
		    self:adjustAngle(counter_angle,dt,1)--num/5)
           if 1 then--intersects(ahead1,ahead2,i) then
        
                i.collided = 1
             -- if intersects(ahead1,ahead2,i) then 
              --  self.de = self.de *dista 
            end
        end
        --self.resolveCollision(self,cc)
    end
    if len == 0 then 
        self.notBumped = (self.notBumped or 0) +1
    else
        self.notBumped = 0
    end
    if self.notBumped>=5 then
        self.bx, self.by = 0,0
    end
    self.deep = (self.deep or 0)+dt
    if self.oldc and-- self.oldc and ((self.oldc.x==self.col.x) or (self.oldc.y==self.col.y)) then
    self.oldc==self.col then
        if self.deep>=2 then
            self.oldc=nil
            local i = self.col
            local dis = dist(i.x,i.y, self.x,self.y,true)
            local sdis = math.sqrt(dis)
            local dista = 1/sdis
        
            self.de = 1--self.de*dista*1000
            self.dd = self.de
            if self.goal then
               -- self.angle = 1
                self:findPathTo(self.goal.x,self.goal.y)
            end
        end
    else
      --  if self.deep >
        self.deep = 0
    end
        
    
    return actualX, actualY
end
    
function Boid:findPathTo(x,y)
    if type(x)=="table" then
        y=x.y
        x=x.x
    end
    
    local t = getTileP(x,y)
    if not t then return end
    self.goal = t
    local tt = getTileP(self.x, self.y)
    if not tt then return end
    path = luastar:getPath(tt.x,tt.y,t.x,t.y)--,isOpen)
    self.currentPosInPath = 1
    _path = {}
    if path then
        for x,c in path:nodes() do 
            x.x =x:getX()
            x.y=x:getY()
            table.insert(_path,x)
        end
    end
    
    self.path= _path --and path._nodes
    if self.path then for x,i in ipairs(self.path) do
        tt = getTile(i.x,i.y)
        tt.path=4
    end end--  error(inspect({tt.x,tt.y}).."to"..inspect({t.x,t.y})..inspect(self.path))end
    return self.path
end

function Boid:adjustAngle(target_angle,dt,power)
	local power = power or 1
	local target_angle = target_angle
	local angle_diff = target_angle - self.angle
	if math.abs(angle_diff) > math.pi then
		if angle_diff > 0 then
			angle_diff = -(2*math.pi-target_angle+self.angle)
		else
			angle_diff = 2*math.pi-self.angle+target_angle
		end
	end
	if angle_diff > 0 then
		self.angle = self.angle + power*dt
	else
		self.angle = self.angle - power*dt
	end
end

function Boid:draw()
	love.graphics.setColor(255/255,255/255*(20-self.crowded)/20,255/255*(20-self.crowded)/20)
	local x1,y1 = self.x+math.cos(self.angle)*5,self.y+math.sin(self.angle)*5
	local x2,y2 = self.x+math.cos(self.angle+math.pi*0.8)*5,self.y+math.sin(self.angle+math.pi*0.8)*5
	local x3,y3 = self.x+math.cos(self.angle-math.pi*0.8)*5,self.y+math.sin(self.angle-math.pi*0.8)*5
	love.graphics.polygon("line",x1,y1,x2,y2,x3,y3)
	love.graphics.rectangle("line",self.x,self.y,self.w,self.h)
end

return Boid