function love.load()
	random = love.math.random
	inspect = require "inspect"
    class = require "tools/class"
	Vector = require "src/core.vector"
	luastar = require "luastar"
	Agent = require "src/agent/steeringAgent"
	boids = require "boids"    
    JumperGrid = require "jumper.grid"
    PathFinder = require "jumper.pathfinder"
    lume = require "tools/lume"
    colors = require "tools/color"
    vector = require "vector_light"
    require "tools/tools"
    bump = require "tools/bump"
    
    world = bump.newWorld()
    
	W,H = love.graphics.getWidth(), love.graphics.getHeight()
	field = {}
	obstacles = {}
	cursor = {x=0,y=0,press = false}
	
	map = {}
	mapGrid = {}
	allTiles = {}
	size = math.floor(H)/50
	for x=1,math.floor(H/size) do
	    map[x] = {}
	    for y = 1,math.floor(H/size) do
	        map[x][y] = {x=x,y=y,_x=size*(x-1),_y=size*(y-1)}
	        table.insert(allTiles, map[x][y])
	        if (y==1 or y==math.floor(H/size)) or (x==1 or x==math.floor(H/size)) then
	            local t = map[x][y]
	            t.taken = 2
	        	table.insert(obstacles,{x=t._x,y=t._y, w=size,h=size,isObstacle=1})
	        	local o = obstacles[#obstacles]
    	    	world:add(o,o.x,o.y,o.w,o.h)
    	    end
	     end
	end
	
    for x,c in ipairs(allTiles) do
        local x,y = c.x, c.y
        mapGrid[y] = mapGrid[y] or {}
        mapGrid[y][x] = c
    end
    	
	function isOpen(t)
	 --   local t = getTile(x,y) --
--	 if 5 then return 5 end
	    if t and t.taken==2 then
	        return false
	    elseif t then
	        return true
	    end
	    return error(x..","..y)
	end

    _grid = JumperGrid(mapGrid)
    pathfinder = PathFinder(_grid,"ASTAR",
        isOpen
    )

    pathfinder:setMode("ORTHOGONAL")
    luastar  = pathfinder
	function getTileP(x,y)
	    x = math.floor(x/size)
	    y = math.floor(y/size)
	    return map[x] and map[x][y]
	end
	
	function getTile(x,y)
	    return map[x] and map[x][y]
	end

	
	
	for i = 1, 1 do
	    local t
	    while not t or t.taken do
	        t = choice(allTiles)
	    end
	    t.taken = 1
		table.insert(field,boids:new({
		    x = t._x,
		    y = t._y,
		    angle = 1}
		   ))
	end
	
	for i = 1, 120 do
	    
	    local t
	    while not t or t.taken do
	        t = choice(allTiles)
	    end
	    t.taken = 2
		table.insert(obstacles,{x=t._x,y=t._y, w=size,h=size,isObstacle=1})
		local o = obstacles[#obstacles]
		world:add(o,o.x,o.y,o.w,o.h)
	end
end

function love.update(dt)
	cursor.x,cursor.y = love.mouse.getPosition()
	if love.mouse.isDown then cursor.press = true else cursor.press = false end
	for i,boid in ipairs(field) do
		boid:update(i,dt,field)
	end
end

local w = 10
function love.draw()
	    local r,g,b,a=love.graphics.getColor()
	for _,obs in ipairs(obstacles) do
	    love.graphics.setColor(obs.collided and colors.purple or colors.brown)
	    love.graphics.rectangle("fill",obs.x,obs.y,obs.w,obs.h)
	    love.graphics.setColor(r,g,b,a)
	end
	for _,boid in ipairs(field) do
		boid:draw()
	end
	love.graphics.rectangle("line",cursor.x,cursor.y,w,w)
	if 1 then
	    for x, i in ipairs(allTiles) do
	        if i.taken==1 then
	            love.graphics.setColor(0,1,0)
	           end
	        if i.path then
	            love.graphics.setColor(0,0,1)
	       end
	        love.graphics.rectangle("line",i._x,i._y,size,size)
	        love.graphics.setColor(r,g,b,a)
	    end
	end
end

local re = function(r) return r end
function dist(x1,y1,x2,y2,notsqrt)
    if type(x1)=="table" then
        local y = y1
        x1, y1 = x1.x, x1.y
        if type(y)=="table" then
            x2,y2 = y.x, y.y
        end
    end
    local sqrt = not notsqrt and math.sqrt or re
	return sqrt((x1-x2)^2+(y1-y2)^2)
end

function choice(list)
    return list[math.random(1,#list)]
end