--calss.lua modified from rotlove's class

local BaseClass = {timeMade=-1}
CLASSES = {BaseClase=BaseClass}
POOLS = {}

local function _includeMixin(aClass, mixin)
    assert(type(mixin)=='table', "mixin must be a table")
    for name,method in pairs(mixin) do
        if not aClass[name] then
            aClass[name] = method
        elseif type(aClass[name])=="function" and type(method)=="function" then
            aClass["old"..name] = aClass[name]
            local f = aClass[name]
            aClass[name] = function(...)
                local r, f = f(...),method(...)
                return r,f
            end
        end
    end

end

local function destroyFunc(self,...)
    local notActive = POOLS[self.__class].notActive local te = #notActive
    local te = #notActive
            --if self.isBullet then --log(#notActive.." pool at "..self.__id.." is being freed.") end
    --assert(self.__active,self.__id)
    self.__active = false
    notActive[#notActive+1] = self.__id
    assert(#notActive<=self.poolSize,#notActive)
            --if self.isBullet or self.isPuffv then --log(#notActive.." des2") end

    local re = self._destroy(self,...)
    assert(#notActive-te==1,self.class)
    return re
end

local function passiveDestroyFunc(self,...)
    local notActive = POOLS[self.__class].notActive local te = #notActive
    local te = #notActive
            --if self.isBullet then --log(#notActive.." pool at "..self.__id.." is being freed.") end
    --assert(self.__active,self.__id)
    self.__active = false
    notActive[#notActive+1] = self.__id
    assert(#notActive<=self.poolSize,#notActive)
            --if self.isBullet or self.isPuffv then --log(#notActive.." ppes2") end

    local re = self._pdestroy(self,...)
    assert(#notActive-te==1,self.class)
    return re
end

local function oldNew(self,...)
    local t = setmetatable({}, self)
    t:__init__(...)
    local kw = ...
    t._kwargs = t._kwargs or t.kwargs or (kw and type(kw)=="table" and kw)
    t.timeMade = love.timer.getTime()
    if store then
        store(t)
    end
    return t
end

function BaseClass:new(...)
    local t = setmetatable({}, self)
    t:__init__(...)
    local kw = ...
    t._kwargs = t._kwargs or t.kwargs or (kw and type(kw)=="table" and kw)
    t.timeMade = love.timer.getTime()
    if store then
        store(t)
    end
    return t
end

function BaseClass:include(...)
    for x, i in ipairs({...}) do
        _includeMixin(self, i)
    end
end
    
function BaseClass:extend(name, t, tt)
    assert(name, "Class must have a name!")
    
    local p = t
    if type(t)~="table" then
        t = nil
    else
        p = tt
    end
    
    t = t or {}
    if type(p)=="number" then
        t.poolSize = p
    end
    t.__index = t
    t.__class = name
    t.class = name
    t.super = self
    --[[t.__data = t.__data or t.data or {
        x=0,y=0,w=0,h=0,_w=0,_h=0,source="none.png",
        active=false,attack=0,life=0,passive=true,vy=0,vx=0,
        _x=0,_y=0,parent={},ax=0,ay=0,speed=0,
        
    }]]
    
    t.poolSize = t.poolSize or 1000
    t.pool = p
    
    local tclass = setmetatable(t, { __call = self.new, __index = self })
    tclass.__lt = self.__lt

    CLASSES[name] = tclass
    t["is"..name] = true
    t.oldnew = t.oldnew or t.new
    
    if not OBJECT_POOLING or not p then
        return tclass
    end
    t.__data.map = game.map
    --log("pooling "..name)
    

    t = tclass
    
    local poolSize = t.poolSize
    local notActive = {}
    local pool = {}
    local __id
    if not self.__taggezd then
        --so won't get repeatedly added to notActive
        --from inheritance though does not work if 
        --super form is not called
        
        local destroy = t.destroy or null
        local pdestroy = t.passiveDestroy or null
        t._destroy = destroy
        t._pdestroy = pdestroy
        t._hasP = pdestroy~=null
        t._hasD = destroy~=null
        
        function t:destroy(...)
            notActive[#notActive+1] = self.__id
            return destroy(self,...)
        end
        
        function t:passiveDestroy(...)
            notActive[#notActive+1] = __id
            return pdestroy(self,...)
        end
        
    end
    
    --populating pool
    local pp
    local notYet = true
    for i = 1, poolSize do
        __id = i
        pool[i] = t:oldnew(t.__data)
        pool[i].__id = i
        pool[i]:destroy()
        pool[i].passive = false
        pp=i
    end
    if t._hasD then
        t._hasD = nil
        t.destroy = t._destroy
    end
    if t._hasP then
        t._hasP = nil
        t.passiveDestroy = t._pdestroy
    end
    
    local nonTotal = #notActive
    
    local function new(self,...) _G["llkg"..t.__class]=4-- if self.isBullet then error() end
        assert(#notActive>=1,"No space left in pool:size "..nonTotal.."!")
        if self.class~=name then
            return oldNew(self,...)
        end
        --log(#notActive.." old")
        local r = table.remove(notActive,1)
        
        --log(#notActive.." "..name.." is making at "..r)
        local obj = pool[r]
        if not obj.__tagged then
            assert(obj.destroy~=destroyFunc,r)
            obj._destroy = obj.destroy
            obj.destroy = destroyFunc
            obj._pdestroy = obj.passiveDestroy or null
            obj.passiveDestroy = passiveDestroyFunc
            obj.__tagged = true
        end
        
        obj:__init__(...)
        obj.__active = true
        obj.destroyed = false
        obj.dead = false
        
        
        local kw = ...
        obj._kwargs = obj._kwargs or obj.kwargs or (kw and type(kw)=="table" and kw)
        obj.timeMade = love.timer.getTime()
        if store then
            store(obj)
        end
        return obj
    end
    
    t.new = new
    
    
    
    POOLS[name] = {pool=pool,notActive=notActive}
    
    return tclass
end

function BaseClass:__init__()
end


function BaseClass.__lt(self,b)
    return self.timeMade<b.timeMade
end

function BaseClass:callSuper(func,...)
    if not self.super[func] then
        return
    end
    return self.super[func](self,...)
end

return BaseClass